#! c:\perl\bin\perl.exe

use strict(vars);
use Win32::Lanman;

my ($server,$op);

do{
 system("cls");
 print "\n\nServer Name: ";
 $server = <STDIN>;
 chomp $server;
 if ($server eq "") {
  $server = Win32::NodeName;
  print $server;
 }
 \&AuditPol($server);
 print "\n\nQuery another server?(y/n)";
 chomp ($op = <STDIN>);
}until ($op eq "n" || $op eq "N");


sub AuditPol {
    my($server) = @_;
    my(%info);
    my(%hash) = ("AuditCategoryLogon" => "Logon and Logoff",
            "AuditCategoryObjectAccess" => "File and Object Access",
            "AuditCategoryPrivilegeUse" => "Use of User Rights",
            "AuditCategoryAccountManagement" => "User/Group Mgmt",
            "AuditCategoryPolicyChange" => "Security Policy Changes",
            "AuditCategorySystem" => "Restart and Shutdown System",
            "AuditCategoryDetailedTracking" => "Process Tracking",
            "AuditCategoryDirectoryServiceAccess" => "Dir. Service Access",
            "AuditCategoryAccountLogon" => "Account Logon");

 my(%settings) = (0 => "None",
                 1 => "Success",
                 2 => "Failure",
                 3 => "Success and Failure");

 if (Win32::Lanman::LsaQueryAuditEventsPolicy("\\\\$server",\%info)) {
        my $audit = $info{auditingmode};
        if (!$audit) {
            print "\n\nError: Auditing is NOT enabled!\n";
        }
        else {
            printf "\n\n%-35s %-20s\n","Audit Events","Settings";
            printf "%-35s %-20s\n","------------","--------";
            my $options = $info{eventauditingoptions};
            foreach my $key (keys %hash) {
                printf "%-35s %-20s\n", $hash{$key},$settings{$$options[&$key]};
            }
        }
    }
    else {
        my $err = Win32::FormatMessage Win32::Lanman::GetLastError();
        print "Error: $err\n";
    }
}