#! c:\perl\bin\perl.exe
use Digest::SHA1;

$policy = "files.cfg"; #policy
$audit = "audit.cfg";   #audit policy configuration
$hashs = "hashs.db";
$startup = "start.db";
$err = 0;
@config = ($policy,$audit,$startup);

system("cls");
print "\n\n\n        Generating hashs database....\n\n";
$dir = `cd`;  #mudar depois....
chomp $dir;
print "Base Directory: $dir\n";
print "File Policy   : $policy\n";
print "Hash file     : $hashs\n";
print "Audit cfg     : $audit\n";
print "Startup file  : $startup\n\n";


unless (open (DB,"> $hashs")) {
 print "Could not open hashs file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

#Check all startup registry keys and startup folders
#qx("startup.pl > $startup");

my ($adsnum,$base,@macs);

#Checking cofiguration files...
foreach my $cfgfile (@config) {
 $adsnum = qx("adscount.pl $cfgfile");
 $base = hashsum($cfgfile);
 @macs = (lstat($cfgfile))[7..10];
 print "Hash $cfgfile: $base\n";
 print DB "$cfgfile;$macs[1];$macs[2];$macs[3];$macs[0];$adsnum;$base\n";
}

unless (open (POL, "$policy")) {
 print "Could not open policy file: $!\n";
 print "\n\n\nPress <RETURN> to continue....";
 $_ = <STDIN>;
 die "\n";
}

while (<POL>){
 $file = $_;
 chomp $file;
 if (-e $file) {
  $adsnum = qx("adscount.pl $file");
  $base = hashsum($file);
  @macs = (lstat($file))[7..10];
  print "Hash $file: $base\n";
  print DB "$file;$macs[1];$macs[2];$macs[3];$macs[0];$adsnum;$base\n"
 }
 else {
       print DB "$file;ERR\n";
       $err = 1;
       print "Can't open $file...\n";
 }
}
close(POL);
close(DB);
$base = hashsum($hashs);
open (SUM,"> $hashs.sum") || die "Could not open sum file: $!\n";
print SUM "$hashs\t$base";
close(SUM);
if ($err == 1) { print "\n\nThere were files NOT processed in the policy!!!"; }
print "\n\n\nPress <RETURN> to continue....";
$_ = <STDIN>;


sub hashsum {
  my ($file) = @_;
  open (FILE, "$file") || die "Can't open $file: $!\n";
  binmode(FILE);
  $digest = Digest::SHA1->new->addfile(*FILE)->hexdigest;
  close (FILE);
  return $digest;
}